<?php
//TODO upload from string
//TODO introduce cache 
class Configuration
{
  var $configFile = '';
  var $items = array();
  var $path = array();
  var $l = 0;
  var $moved = false; 
  
  function Configuration(){
    //init

  }
  
  function get_template($url) {
	// If CACHE ENABLED
	if ($this->edgeioconf["CACHE_PATH"] != '') {
		$cache_file = $this->edgeioconf["CACHE_PATH"] . '/conf_' . md5($url);
		$timedif = @(time() - filemtime($cache_file));
		if ($timedif < $this->edgeioconf["CACHE_TIME"]) {
			// cached file is fresh enough, return cached array
			$result = unserialize(join('', file($cache_file)));
			// set 'cached' to 1 only if cached file is correct
			if ($result) $result['cached'] = 1;
		} else {
			// cached file is too old, create new
			if($result = $this->get_url($url)){
				$serialized = serialize($result);
				if ($f = @fopen($cache_file, 'w')) {
					fwrite ($f, $serialized, strlen($serialized));
					fclose($f);
				}
				if ($result) $result['cached'] = 0;
			}else{
				// cant connect re use stale data
				$result = unserialize(join('', file($cache_file)));
				// set 'cached' to 1 only if cached file is correct
				if ($result) $result['cached'] = 1;
			}
		}
	}
	// If CACHE DISABLED >> load and parse the file directly
	else {
		$result = $this->get_url($url);
		if ($result) $result['cached'] = 0;
	}
	return $result;
  }
	
  function get_url($_url){
    $this->original_url=$_url;
    $url = parse_url($_url);
    $http_client = new edgeio_http( HTTP_V11, false);
    $http_client->host = $url['host'];
    
    if($url['query']!=''){
      $query = $url['path'] . '?' . $url[query]; 
    }else{
      $query = $url['path'];
    }
    
    if ( $http_client->get($query) == HTTP_STATUS_OK){
        $rs = $http_client->get_response_body();
        unset( $http_client );
        return $rs;
    }else{
        unset( $http_client );
        $error = 'Server returned ' .  $http_client->status;
        return false;
    }
  }
  
  
  function parse($input){
   $xml_parser = xml_parser_create('');
    xml_parser_set_option($xml_parser,XML_OPTION_SKIP_WHITE,1);
	xml_parser_set_option ($xml_parser,XML_OPTION_CASE_FOLDING,0);//Don't put tags uppercase
	
	if($input['file']!=''){
	  $file = $input['file'];
		if (!($fp = fopen($file, "r"))) {
		    die("could not open XML input");
		}
		$data = fread($fp, filesize($file));
		fclose($fp);
	}
	
	if($input['url']!=''){
	  //get url data here
	  if (!($data = $this->get_template($input['url']))) {
		    die("could not open remote XML input");
	  }
	}
		
	xml_parse_into_struct($xml_parser, $data, $vals, $index);
	xml_parser_free($xml_parser);
	
	$items = array();
	$level = array();
	
	foreach ($vals as $key => $xml_elem) {
	 if ($xml_elem['type'] == 'open') {
	    $level[$xml_elem['level']] = $xml_elem['tag'];
		    if($this->path[implode('_',$level)]>0){
		      $indx = $this->path[implode('_',$level)];
		      $this->path[implode('_',$level)] = $this->path[implode('_',$level)] + 1;
		    }else{
		      $this->path[implode('_',$level)] = 1;
		      $indx = 0;
		    }
	    
	 }elseif($xml_elem['type'] == 'close'){
	    unset($level[count($level)]);
	    $this->moved = false;
	 }elseif ($xml_elem['type'] == 'complete') {
	    
	    $start_level = 1;
	    $php_stmt = '$items';
	    
	    while($start_level < $xml_elem['level']) {
	      $php_stmt .= '[$level['.$start_level.']]';
	      $start_level++;
	    }
	    
	    if((($vals[$key]['level']==$vals[$key+1]['level'])&&($vals[$key]['tag']==$vals[$key+1]['tag']))||(($vals[$key]['level']==$vals[$key-1]['level'])&&($vals[$key]['tag']==$vals[$key-1]['tag']))){
	      //same tag same level , make an array of it
	      if($indx > 0){
	       $php_stmt .= '['.$indx.'][$xml_elem[\'tag\']]['.$this->l.'] = $xml_elem[\'value\'];';
 	       $this->l++;
	      }else{
	       $php_stmt .= '[$xml_elem[\'tag\']]['.$this->l.'] = $xml_elem[\'value\'];';
 	       $this->l++;  
	      }
	    }else{
	      if($indx > 0){ 
	       $this->l=0; //reset

	       if(($indx==1)&&(!$this->moved)){
	         $root = '$items';
	         foreach($level as $key=>$value){
	           $root .= '[\''.$value.'\']';
	         }
	         
	        eval('foreach('.$root.' as $key => $value){'.$root.'[0][$key] = $value; unset('.$root.'[$key]);} return true;');
	        $this->moved = true;
	       }
	       
           $php_stmt .= '['.$indx.'][$xml_elem[\'tag\']] = $xml_elem[\'value\'];';
	      }else{
	       $this->l=0; //reset
           $php_stmt .= '[$xml_elem[\'tag\']] = $xml_elem[\'value\'];';  
	      }
	    }
	    eval($php_stmt);
	  }
	}
	
   $this->items = $items;
  }	
}
?>