<?php
class Board
{
  
  function Board(){
    //init
	
  }
  
  function verify_prefix($uri,$prefix){
  	if($prefix==''){
  	 return $uri;	
  	}	
  
	if(strpos($uri,$prefix)===false){
	  return $uri.$prefix;	
	}else{
	  return $uri;	
	}  	
  }

  function parse(&$conf,$firsturl=''){
   foreach($conf['boards'] as $bkey => $board){
       $txt  = $conf['templates']['index']['layout_index_board'];
       $txt = str_replace("<#board_name#>",$board['name'],$txt);
	   $vertical = $board['vertical'];
	 
           $request = explode('?',$_SERVER['REQUEST_URI']);
	       //remove edgeio application parameters leaving only consumer app pass throughs 
	       parse_str($request[1],$query);
	       unset($query['tpl']);
	       unset($query['rss']);
	       unset($query['from']);
	       $request[1] = http_build_query($query);
           $links='';
           if($request[1]!=''){
             $addparam = '&'.$request[1];	
           } 
         foreach($board['categories']['category'] as $ckey => $category){
          
          if($category['vertical']!=''){
          	$vertical = $category['vertical'];
          }
          
          if(trim($category['rss'])==''){
          
          	$conf['boards'][$bkey]['categories']['category'][$ckey]['rss'] = str_replace("/BASESEARCH/",urlencode(str_replace(' ','-',$category['name'])),$conf['base_rss']);
          
            if($vertical!=''){
           	 $conf['boards'][$bkey]['categories']['category'][$ckey]['rss'] = str_replace("_v_t", "_v_" . urlencode(str_replace(' ','-',$vertical))."_t",$conf['boards'][$bkey]['categories']['category'][$ckey]['rss']);
            }
          
          }	
         
          if($firsturl!=''){
           $url = $this->verify_prefix($request[0],$conf['prefix']) . "?tpl=".md5($_SERVER['REQUEST_URI'].$board['name']."-".$category['name'])."&rss=". urlencode($bkey."-".$ckey."-".$board['name']."-".$category['name']) .$addparam;
           return $url;	
          }else{
           $links .= "<a href='".$this->verify_prefix($request[0],$conf['prefix']) . "?tpl=".md5($_SERVER['REQUEST_URI'].$board['name']."-".$category['name'])."&rss=". urlencode($bkey."-".$ckey."-".$board['name']."-".$category['name']) .$addparam . "' class='edgeio_category_link'>".$category['name']."</a><br/>"."\n";
          }
	     }
	     
	     $txt = str_replace("<#board_links#>",$links,$txt);
	     $conf['boards'][$bkey]['html']=$txt;
      }
  }
  
  function drawindex(&$conf,$boardindex=''){
    $index = $conf['templates']['index']['layout_index'];
    
    if($conf['boards'][$boardindex]['html']!=''){
      $index = $conf['boards'][$boardindex]['html'];
    }else{
	    foreach($conf['boards'] as $bkey => $board){
	      $index = str_replace("<#$bkey#>",$conf['boards'][$bkey]['html'],$index);
	    }
    }
    return $index; 
  }
  
   function drawindexdetails(&$conf,$details,$rss_board){

       $board=$conf['boards'][$rss_board[0]];
   	   $txt  = $conf['templates']['index']['layout_index_board'];
       $txt = str_replace("<#board_name#>",$rss_board[3],$txt);
   	   $request = explode('?',$_SERVER['REQUEST_URI']);
	   
	   //remove edgeio application parameters leaving only consumer app pass throughs 
	   parse_str($request[1],$query);
	   $tpl = $query['tpl'];
	   unset($query['tpl']);
	   $rss = $query['rss'];
	   unset($query['rss']);
	   unset($query['from']);
	   unset($query['bc']);
	   unset($query['edgeop']);
	   
	   $request[1] = http_build_query($query);
       $links='';
        if($request[1]!=''){
         $addparam = '&'.$request[1];	
        } 
         foreach($details as $ckey => $category){
	       $links .= "<a href='".$this->verify_prefix($request[0],$conf['prefix']) . "?tpl=".$tpl."&rss=". urlencode($rss)."&bc=".urlencode($category) . $addparam . "' class='edgeio_category_link'>".$category."</a><br/>"."\n";
	     }
	     if($links==''){
			return $links; //no links return nothing so we dont display junk	     	
	     }
	   $txt = str_replace("<#board_links#>",$links,$txt);
	   $conf['boards'][$bkey]['details']=$txt;
    
    return $txt; 
  }
  
  function build_histogram($histogram,&$conf){
	  $content='';
	  $i=0;
	 
	 //rebuild query
	  $request = explode('?',$_SERVER['REQUEST_URI']);
	   
	   //remove edgeio application parameters leaving only consumer app pass throughs 
	   parse_str($request[1],$query);
	   unset($query['edgeio_search']);
	   $tpl = $query['tpl'];
	   unset($query['tpl']);
	   $rss = $query['rss'];
	   unset($query['rss']);
	   unset($query['from']);
	   unset($query['bc']);
	   unset($query['n']);
	   $request[1] = http_build_query($query);
       
       if($request[1]!=''){
         $addparam = '&'.$request[1];	
       } 
	  
	 foreach($histogram as $key => $value){
	  if($i < $conf['templates']['histogram']['index_size']){ //limit index
	    $title = $value['title'];
	    $links='';
	    $d=0;
	 	
	 	foreach($value['links'] as $lkey => $lvalue){
	 	
	 	$p = explode('?',html_entity_decode($lvalue['href']));
	 	
	 	if($p[1]!=''){
	 	 parse_str($p[1],$pq);
	 	 unset($pq['edgeio_search']);
	 	 unset($pq['tpl']);
	 	 unset($pq['rss']);
	 	 unset($pq['from']);
	 	 unset($pq['bc']);
	 	 unset($pq['n']);
	 	}else{
	 	 $pq=array();	
	 	}
	 	
	 	$histparam = rtrim('&'.trim(trim($addparam,'&').'&'. http_build_query($pq),'&'),'&');

	 	 if($d < $conf['templates']['histogram']['detail_size']){ //limit index
	 	  
	 	  $links .= '<a href="'.$request[0] . '?tpl='.$tpl.'&rss='.urlencode($rss."-".$lvalue['label']). '&n='.$this->my_preg_match("'/s2/(.*?).html'si", $p[0]).$histparam .'" class="edgeio_histogram"><span>'.$lvalue['label'].'</span></a><span class="edgeio_histogram_count"> ('.$lvalue['count'].')</span><br/>';	
	 	  $d++;
	 	 } //if $d 	
	 	}
	   
	   //build a histogram box
	   $histogram_detail = $conf['templates']['histogram']['detail'];
	   $histogram_detail = str_replace("<#histogram_name#>",$title,$histogram_detail);	
	   $histogram_detail = str_replace("<#histogram_links#>",$links,$histogram_detail);
	    if($links!=''){
	     $content .= $histogram_detail;
	    }  	
	  } //if $i	
	  $i++;
	 }
	   $histogram_index = $conf['templates']['histogram']['index'];
	   $histogram_index = str_replace("<#histogram_index_name#>",$conf['templates']['histogram']['index_name'],$histogram_index);	
	   $histogram_index = str_replace("<#histogram_index_details#>",$content,$histogram_index);
	   if($content==''){
	   	return $content; //display empty if nothing
	   }
	  return $histogram_index; 	
   } 
   
   	function my_preg_match ($pattern, $subject) {
		// start regullar expression
		preg_match($pattern, $subject, $out);

		// if there is some result... process it and return it
		if(isset($out[1])) {
			return trim($out[1]);
		} else {
		// if there is NO result, return empty string
			return '';
		}
	}   
    
 }
?>